# Převod řetězce na číslo v desítkové soustavě a zpět.

ORD_ZERO = ord("0")

def char_to_digit(char):
    return ord(char) - ORD_ZERO

"""    
>>> char_to_digit("1")
1
"""
def append_digit(number, digit):
    return (number * 10) + digit

"""
>>> append_digit(12, 3)
123
"""

def string_to_number(string):
    result = 0
    for char in string:
        digit = char_to_digit(char)
        result = append_digit(result, digit)
        print(repr(char), digit, result)
    return result

"""
>>> string_to_number("123")
123
"""
# Na zamyšlení:
"""
>>> char_to_digit("a")
10
>>> string_to_number("1f", 16)
31
"""
"""
>>> chr(49)
'1'
"""

def digit_to_char(digit):
    return chr(digit + ORD_ZERO)

"""
>>> digit_to_char(5)
'5'
"""

def get_last_digit(number):
    return number % 10

def remove_last_digit(number):
    return number // 10

def number_to_string(number):
    string = ""
    while number > 0:
        digit = get_last_digit(number)
        char = digit_to_char(digit)
        string = char + string
        number = remove_last_digit(number)
        # print(number, repr(string), digit, repr(char))
    return string

"""
>>> number_to_string(123)
"123"
"""
# K zamyšlení:
"""
>>> number_to_string(123, 16)
"7b"
"""
