# Převod řetězce na číslo v obecné soustavě a zpět.
# Povolené základy soustav: 2, 8, 10 a 16

ORD_ZERO = ord("0")
ORD_A = ord("a")

def char_to_digit(char):
    ord_char = ord(char)
    if ord_char >= ORD_A:
        return (ord_char - ORD_A) + 10
    else:
        return ord_char - ORD_ZERO
    
"""    
>>> char_to_digit("1")
1
>>> char_to_digit("a")
10
"""
def append_digit(number, digit, base=10):
    return (number * base) + digit

"""
>>> append_digit(12, 3)
123
"""

def string_to_number(string, base=10):
    result = 0
    for char in string:
        digit = char_to_digit(char)
        result = append_digit(result, digit, base)
        print(repr(char), digit, result)
    return result

"""
>>> string_to_number("123")
123
>>> char_to_digit("a")
10
>>> string_to_number("1f", 16)
31
"""
"""
>>> chr(49)
'1'
"""
# Dodělat pro obecné soustavy:
def digit_to_char(digit):
    return chr(digit + ORD_ZERO)

"""
>>> digit_to_char(5)
'5'
"""

def get_last_digit(number):
    return number % 10

def remove_last_digit(number):
    return number // 10

def number_to_string(number, base=10):
    string = ""
    while number > 0:
        digit = get_last_digit(number)
        char = digit_to_char(digit)
        string = char + string
        number = remove_last_digit(number)
        # print(number, repr(string), digit, repr(char))
    return string

"""
>>> number_to_string(123)
"123"
>>> number_to_string(123, 16)
"7b"
"""
